package solutions.bitbadger.documents.sqlite

import org.junit.jupiter.api.DisplayName
import solutions.bitbadger.documents.common.Document
import kotlin.test.Test

/**
 * SQLite integration tests for the `Document` object / `insert`, `save`, `update` connection extension functions
 */
@DisplayName("SQLite - Document")
class DocumentIT {

    @Test
    @DisplayName("insert works with default values")
    fun insertDefault() =
        SQLiteDB().use(Document::insertDefault)

    @Test
    @DisplayName("insert fails with duplicate key")
    fun insertDupe() =
        SQLiteDB().use(Document::insertDupe)

    @Test
    @DisplayName("insert succeeds with numeric auto IDs")
    fun insertNumAutoId() =
        SQLiteDB().use(Document::insertNumAutoId)

    @Test
    @DisplayName("insert succeeds with UUID auto ID")
    fun insertUUIDAutoId() =
        SQLiteDB().use(Document::insertUUIDAutoId)

    @Test
    @DisplayName("insert succeeds with random string auto ID")
    fun insertStringAutoId() =
        SQLiteDB().use(Document::insertStringAutoId)
}
